Subject: Re: git-send-email and IPv6-only host

From: Stéphane Graber <[email-masked]>
Date: Fri, 28 Aug 2015 13:32:59 -0400

On Fri, Aug 28, 2015 at 10:19:09AM -0700, Junio C Hamano wrote:
> Stéphane Graber <[email-masked]> writes:
> 
> > Hello,
> >
> > I've recently switched my home network to be IPv6-only, using NAT64 and
> > DNS64 to reach IPv4 hosts. Pretty much everything I use day to day just
> > kept on working fine, but I keep finding some small problems here and
> > there, mostly to do with perl software.
> >
> > One of those is git-send-email which isn't capable of talking to an IPv6
> > SMTP server.
> >
> > I've locally patched my git-send-email to add:
> >
> >     require Net::INET6Glue::INET_is_INET6;
> >
> > This seems to be the magic bullet for all IPv6 problems I've had with
> > perl software, though I'm not sure whether this is an acceptable fix
> > upstream as this does bring an additional dependency to git-send-email.
> 
> I wonder what happens if you 'require' that Glue on a host that is
> not IPv6-only.
> 
> What I am trying to get at is if what that Glue thing does is an
> acceptable thing to do in the Net::* Perl modules (e.g. Net::SMTP
> and Net::SMTP::SSL that we use), i.e., what INET6Glue does to work
> around issues in Net::* is a problem Net::* Perl modules should be
> solving for the users of these modules.
> 
> After all, it is madness to ask all packages that use Net::*
> infrastructure, like git-send-email, to 'require' an extra module.
> 
> Thanks.

The require is perfectly safe to do on an IPv4-only machine. My
understanding is that it basically replaces any call to gethostbyname
and hardcoded AF_INET sockets to instead using getaddrinfo and iterating
through the results, therefore covering all the socket families.

I indeed find it very weird that perl itself hasn't just done that in
the main networking module, but it's something that's been an issue for
years now (I first experimented with IPv6-only in 2010) and doesn't seem
to be improving at all.

Note that most other languages seem to have resolved that issue by now
so I'm unsure why perl appears to be lagging behind there...

Stéphane